[[SET DRIVER

        LOC Data_Segment+0
AVAIL_B GREG @
        [[INIT]]
AVAIL_I GREG @ % top of initial data
AVAIL   GREG 0

        LOC Data_Segment+8000
        GREG @
EXP1    [[EXP1]]

        [[INCLUDE msg.mms]]
        
        LOC #100
        GREG @
        
        [[INCLUDE octa2ascii.mms]]
        [[INCLUDE compare.mms]]
        
        [[INCLUDE S232PD-COPYRTBT.mms]]
        
Main    SET AVAIL,AVAIL_I

        SET $1,AVAIL_B
        PUSHJ $0,COPYRTBT    % COPY(P)
        
        SET $1,AVAIL_B
        LDA $2,EXP1
        SET $3,12
        PUSHJ $0,COMPARE

        SET $255,0
        TRAP
]]

[[TEST 1]]
[[COMMENT Topology: two linked nodes, the top one being right-threaded
to another node which must of course not be copied in the process.

                               | right-thread to another node
                     (10)      /
                    /  |  \___/
                   /   |
                  (20)-/ right-thread

]]
[[SET INIT
        OCTA #3000000000000001 % node (10)
        OCTA #2000000000000018
        OCTA 10
        OCTA #2000000000000001 % node (20)
        OCTA 0
        OCTA 20
]]
[[SET EXP1 OCTA #3000000000000001 % node (10)
           OCTA #2000000000000018
           OCTA 10
           OCTA #2000000000000001 % node (20)
           OCTA 0
           OCTA 20
           % COPY
           OCTA 0 % original RT-link must not be copied
           OCTA #2000000000000048
           OCTA 10
           OCTA #2000000000000031
           OCTA 0
           OCTA 20
]]
[[DRIVER]]
[[END 1]]

